(function() {
	var Watermark = function(canvas, image, option, callback) {
		this.canvas = canvas;
		this.image = image;
		this.option = option;
		this.callback = callback;
		this.init();
	};
	
	Watermark.prototype = {
		background_left: 0,
		background_top: 0,
		background_width: 0,
		background_height: 0,
		text_left: 0,
		
		init: function() {
			var maxlen = 0;
			for(var i in this.option) {
				if(maxlen < this.option[i].length) {
					maxlen = this.option[i].length;
				}
			}
			maxlen = maxlen + 3;
			this.background_width = (maxlen * 24 + 40 < this.canvas.width) ? maxlen * 24 + 40 : this.canvas.width - 40;
			this.background_height = 6 * 40 + 22;
			this.background_left = 20;
			this.background_top = this.canvas.height - this.background_height - 100;
			this.text_left = this.background_left + 20;
		},
		
		draw: function() {
			var canvas = this.canvas;
			var image = this.image;
			var option = this.option;
			var callback = this.callback;
			var background_width = this.background_width;
			var background_height = this.background_height;
			var background_left = this.background_left;
			var background_top = this.background_top;
			var text_left = this.text_left;
			var ctx = canvas.getContext("2d"); 
			if(typeof image == 'string') {
				var newImage = new Image();
				newImage.src = image;
				newImage.onload = function() {
					ctx.drawImage(newImage, 0, 0);
					
					ctx.font = '24px Microsoft YaHei'; //文字样式
					ctx.fillStyle = '#000'; //设置文字颜色
					
					var index = 1;
                    var row = [];
					for(var i in option) {
                        // 1 将字符串转换成数组
                        var test = option[i].split("");
                        var temp = "";
                        var width = background_width - text_left;
                        // 1.2 计算文字宽度，若文字宽度大于设定的宽度，则push到数组下一个元素，否则将字符串++
                        for(var i = 0;  i < test.length; i++ ){
                            if(ctx.measureText(temp).width > width){
                                var last = temp.substr(-1);
                                temp = temp.substr(0, temp.length - 1);
                                row.push(temp);
                                temp = last;
                            }
                            temp += test[i];
                        }
                        // 1.3 循环结束将temp最后一段字符push
                        row.push(temp)
					}
                    ctx.fillStyle = 'rgba(255, 255, 255, 0.5)'; 
                    background_height = row.length * 40 + 22;
                    background_top = canvas.height - background_height - 100;
                    ctx.fillRect(background_left, background_top, background_width, background_height); 
                    // 1.4 遍历数组,输出文字
                    ctx.fillStyle = '#000'; //设置文字颜色
                    for(var j = 0; j < row.length; j++){
                        ctx.fillText(row[j], text_left, background_top + 40 * index);
                        index ++;
                    }
					callback(canvas.toDataURL("image/jpeg"));
				}
			}
		},
	}
	window.Watermark = Watermark; 
})()